#pragma once
#include "acpi/SDT.h"

namespace ACPI
{
    struct XSDT
    {
        SDTHeader header;
        uint64_t PointerToOtherSDT[1];
    };

    struct RSDT
    {
        SDTHeader header;
        uint32_t PointerToOtherSDT[1];
    };

    SDTHeader* GetRSDTOrXSDT();

    bool ValidateRSDTOrXSDT(SDTHeader* rootSDT);

    bool IsXSDT();

    void* FindTable(SDTHeader* rootSDT, const char* signature);
}