#pragma once
#include <stdint.h>

namespace KernelMemoryManager
{
    void* get_mapping(void* physicalAddress);
    void release_mapping(void* mapping);

    void* get_unaligned_mapping(void* physicalAddress);
    void* get_unaligned_mappings(void* physicalAddress, uint64_t count);
    void release_unaligned_mapping(void* mapping);
    void release_unaligned_mappings(void* mapping, uint64_t count);

    void* get_page();
    void* get_pages(uint64_t count);

    void release_page(void* page);
    void release_pages(void* pages, uint64_t count);
}